diff --git a/src/main/java/net/minecraft/core/entity/EntityLiving.java b/src/main/java/net/minecraft/core/entity/EntityLiving.java
index dd8163388..b15c41f72 100644
--- a/src/main/java/net/minecraft/core/entity/EntityLiving.java
+++ b/src/main/java/net/minecraft/core/entity/EntityLiving.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.entity;
 
+import java.util.HashMap;
 import java.util.List;
+import java.util.Map;
 
 import com.b100.utils.StringUtils;
 import com.mojang.nbt.CompoundTag;
@@ -15,6 +17,7 @@ import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemFood;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.DamageType;
@@ -229,6 +232,12 @@ public abstract class EntityLiving extends Entity
 
             }
         }
+        for (Map.Entry<ItemFood, ConsumedFood> entry : consumedFood.entrySet()) {
+            entry.getValue().tick();
+            if (entry.getValue().isFinished()) {
+                consumedFood.remove(entry.getKey());
+            }
+        }
         prevRotationUnused = unusedRotation1;
         prevRenderYawOffset = renderYawOffset;
         yRotO = yRot;
@@ -382,6 +391,19 @@ public abstract class EntityLiving extends Entity
         return 10;
     }
 
+    public void eatFood(ItemFood food) {
+        if (food == null) return;
+        if (food.getTicksPerHeal() == 0) {
+            heal(food.getHealAmount());
+        } else {
+            if (consumedFood.containsKey(food)) {
+                consumedFood.get(food).addFood();
+            } else {
+                consumedFood.put(food, new ConsumedFood(this, food));
+            }
+        }
+    }
+
     @Override
     public boolean hurt(Entity attacker, int damage, DamageType type)
     {
@@ -409,6 +431,7 @@ public abstract class EntityLiving extends Entity
         {
             lastDamage = damage;
             prevHealth = getHealth();
+            prevBonusHealth = bonusHealth;
             heartsFlashTime = heartsHalvesLife;
             damageEntity(damage, type);
             hurtTime = maxHurtTime = 10;
@@ -1184,7 +1207,8 @@ public abstract class EntityLiving extends Entity
     	}
     	return xRot < 0.0f ? Direction.UP : Direction.DOWN;
     }
-	
+
+    protected Map<ItemFood, ConsumedFood> consumedFood = new HashMap<ItemFood, ConsumedFood>();
     public int heartsHalvesLife;
     public float unusedRotationPitch2;
     public float unusedRotationPitch;
@@ -1205,6 +1229,8 @@ public abstract class EntityLiving extends Entity
     public float prevSwingProgress;
     public float swingProgress;
     public int prevHealth;
+    public int bonusHealth;
+    public int prevBonusHealth;
     private int livingSoundTime;
     public int hurtTime;
     public int maxHurtTime;
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java b/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
index 33533782b..e8b1e4ea4 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
@@ -272,7 +272,7 @@ public class EntityWolf extends EntityAnimal
 
         if (getTarget() instanceof EntityItem)
         {
-            if (getTarget().isInWater() || getTarget().isInLava() || getTarget().isInWall())
+            if (getTarget().isInWater() || getTarget().isInLava() || getTarget().isInWall() || !getTarget().onGround || getTarget().isRemoved())
             {
                 setTarget(null);
             }
@@ -316,7 +316,7 @@ public class EntityWolf extends EntityAnimal
                         continue;
                     }
 
-                    if (item.isInWater() || item.isInLava() || item.isInWall())
+                    if (item.isInWater() || item.isInLava() || item.isInWall() || !item.onGround || item.isRemoved())
                     {
                         triedItems.add(item);
                         continue;
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java b/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java
index 04f5ba63c..e525b393e 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java
@@ -105,4 +105,21 @@ public class EntitySnowman extends EntityMonster
         return "mob.zombiedeath";
     }
 
+    @Override
+    protected void dropFewItems()
+    {
+        int i = Item.ammoSnowball.id;
+        if(i > 0)
+        {
+            int j = random.nextInt(3);
+            if (random.nextInt(1000) == 0) {
+                id = Item.bucketIcecream.id;
+                j = 1;
+            }
+            for(int k = 0; k < j; k++)
+            {
+                spawnAtLocation(i, 1);
+            }
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java b/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
index 05a3854b9..ee9b0542c 100644
--- a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
+++ b/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
@@ -64,7 +64,7 @@ public abstract class EntityPlayer extends EntityLiving
         swingProgressInt = 0;
         timeUntilPortal = 20;
         inPortal = false;
-        fishEntity = null;
+        bobberEntity = null;
         inventorySlots = new ContainerPlayer(inventory, !world.isClientSide);
         craftingInventory = inventorySlots;
         heightOffset = 1.62F;
@@ -1393,7 +1393,7 @@ public abstract class EntityPlayer extends EntityLiving
     public Gamemode gamemode = Gamemode.survival;
     public byte field_9371_f;
     public int score;
-    public List<String> messages = new ArrayList<>();
+    public List<String> messageHistory = new ArrayList<>();
     public float field_775_e;
     public float field_774_f;
     public boolean isSwinging;
@@ -1421,7 +1421,7 @@ public abstract class EntityPlayer extends EntityLiving
     public float timeInPortal;
     public float prevTimeInPortal;
     private final int damageRemainder;
-    public EntityBobber fishEntity;
+    public EntityBobber bobberEntity;
     public volatile String skinURL;
     public volatile String capeURL;
     public boolean slimModel = false;
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java b/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
index 1bbf95ea4..cba03dafb 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
@@ -245,8 +245,14 @@ label0:
         {
             minecartCurrentDamage--;
         }
+        double _x = x;
+        double _y = y;
+        double _z = z;
     	onUpdate2();
     	onUpdate2();
+        this.xo = _x;
+        this.yo = _y;
+        this.zo = _z;
     }
 
     public void onUpdate2()
diff --git a/src/main/java/net/minecraft/core/item/Item.java b/src/main/java/net/minecraft/core/item/Item.java
index eec9bfe93..f26d8c7d1 100644
--- a/src/main/java/net/minecraft/core/item/Item.java
+++ b/src/main/java/net/minecraft/core/item/Item.java
@@ -3,7 +3,6 @@ package net.minecraft.core.item;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.data.tag.ITaggable;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.Entity;
@@ -222,12 +221,6 @@ public class Item
         return I18n.getInstance().translateNameKey(getKey());
     }
 
-    public Item setNotInCreativeMenu()
-    {
-        notInCreativeMenu = true;
-        return this;
-    }
-
     public void inventoryTick(ItemStack itemstack, World world, Entity entity, int i, boolean flag)
     {
     }
@@ -243,7 +236,7 @@ public class Item
     
     public boolean isSilkTouch()
     {
-        return this.hasTag(ItemTags.isSilkTouch);
+        return this.hasTag(ItemTags.IS_SILK_TOUCH);
     }
     
     public boolean hasInventoryInteraction() {
@@ -262,34 +255,35 @@ public class Item
     public static final Map<String, Integer> nameToIdMap = new HashMap<>();
 
     public static Item[] itemsList = new Item[32768];
+
     public static Item toolShovelIron = (new ItemToolShovel("tool.shovel.iron", 16384, ToolMaterial.iron));
     public static Item toolPickaxeIron = (new ItemToolPickaxe("tool.pickaxe.iron", 16385, ToolMaterial.iron));
     public static Item toolAxeIron = (new ItemToolAxe("tool.axe.iron", 16386, ToolMaterial.iron));
     public static Item toolFirestriker = (new ItemFirestriker("tool.firestriker", 16387));
-    public static Item foodApple = (new ItemFood("food.apple", 16388, 4, false));
+    public static Item foodApple = (new ItemFood("food.apple", 16388, 4, 4, false, 16));
     public static Item toolBow = (new ItemBow("tool.bow", 16389));
     public static Item ammoArrow = (new Item("ammo.arrow", 16390));
     public static Item coal = (new ItemCoal("coal", 16391));
     public static Item diamond = (new Item("diamond", 16392));
     public static Item ingotIron = (new Item("ingot.iron", 16393));
     public static Item ingotGold = (new Item("ingot.gold", 16394));
-    public static Item toolSwordIron = (new ItemToolSword("tool.sword.iron", 16395, ToolMaterial.iron)).withTags(ItemTags.preventCreativeMining);
-    public static Item toolSwordWood = (new ItemToolSword("tool.sword.wood", 16396, ToolMaterial.wood)).withTags(ItemTags.preventCreativeMining);
+    public static Item toolSwordIron = (new ItemToolSword("tool.sword.iron", 16395, ToolMaterial.iron)).withTags(ItemTags.PREVENT_CREATIVE_MINING);
+    public static Item toolSwordWood = (new ItemToolSword("tool.sword.wood", 16396, ToolMaterial.wood)).withTags(ItemTags.PREVENT_CREATIVE_MINING);
     public static Item toolShovelWood = (new ItemToolShovel("tool.shovel.wood", 16397, ToolMaterial.wood));
     public static Item toolPickaxeWood = (new ItemToolPickaxe("tool.pickaxe.wood", 16398, ToolMaterial.wood));
     public static Item toolAxeWood = (new ItemToolAxe("tool.axe.wood", 16399, ToolMaterial.wood));
-    public static Item toolSwordStone = (new ItemToolSword("tool.sword.stone", 16400, ToolMaterial.stone)).withTags(ItemTags.preventCreativeMining);
+    public static Item toolSwordStone = (new ItemToolSword("tool.sword.stone", 16400, ToolMaterial.stone)).withTags(ItemTags.PREVENT_CREATIVE_MINING);
     public static Item toolShovelStone = (new ItemToolShovel("tool.shovel.stone", 16401, ToolMaterial.stone));
     public static Item toolPickaxeStone = (new ItemToolPickaxe("tool.pickaxe.stone", 16402, ToolMaterial.stone));
     public static Item toolAxeStone = (new ItemToolAxe("tool.axe.stone", 16403, ToolMaterial.stone));
-    public static Item toolSwordDiamond = (new ItemToolSword("tool.sword.diamond", 16404, ToolMaterial.diamond)).withTags(ItemTags.preventCreativeMining);
+    public static Item toolSwordDiamond = (new ItemToolSword("tool.sword.diamond", 16404, ToolMaterial.diamond)).withTags(ItemTags.PREVENT_CREATIVE_MINING);
     public static Item toolShovelDiamond = (new ItemToolShovel("tool.shovel.diamond", 16405, ToolMaterial.diamond));
     public static Item toolPickaxeDiamond = (new ItemToolPickaxe("tool.pickaxe.diamond", 16406, ToolMaterial.diamond));
     public static Item toolAxeDiamond = (new ItemToolAxe("tool.axe.diamond", 16407, ToolMaterial.diamond));
     public static Item stick = (new Item("stick", 16408));
     public static Item bowl = (new Item("bowl", 16409));
-    public static Item foodStewMushroom = (new ItemSoup("food.stew.mushroom", 16410, 10));
-    public static Item toolSwordGold = (new ItemToolSword("tool.sword.gold", 16411, ToolMaterial.gold)).withTags(ItemTags.preventCreativeMining);
+    public static Item foodStewMushroom = (new ItemSoup("food.stew.mushroom", 16410, 10, 8));
+    public static Item toolSwordGold = (new ItemToolSword("tool.sword.gold", 16411, ToolMaterial.gold)).withTags(ItemTags.PREVENT_CREATIVE_MINING);
     public static Item toolShovelGold = (new ItemToolShovel("tool.shovel.gold", 16412, ToolMaterial.gold));
     public static Item toolPickaxeGold = (new ItemToolPickaxe("tool.pickaxe.gold", 16413, ToolMaterial.gold));
     public static Item toolAxeGold = (new ItemToolAxe("tool.axe.gold", 16414, ToolMaterial.gold));
@@ -303,7 +297,7 @@ public class Item
     public static Item toolHoeGold = (new ItemToolHoe("tool.hoe.gold", 16422, ToolMaterial.gold));
     public static Item seedsWheat = (new ItemSeeds("seeds.wheat", 16423, Block.cropsWheat));
     public static Item wheat = (new Item("wheat", 16424));
-    public static Item foodBread = (new ItemFood("food.bread", 16425, 5, false));
+    public static Item foodBread = (new ItemFood("food.bread", 16425, 5, 6, false, 16));
 
     public static Item armorHelmetLeather = (new ItemArmor("armor.helmet.leather", 16426, ArmorMaterial.LEATHER, 0));
     public static Item armorChestplateLeather = (new ItemArmor("armor.chestplate.leather", 16427, ArmorMaterial.LEATHER, 1));
@@ -330,18 +324,18 @@ public class Item
     public static Item armorLeggingsGold = (new ItemArmor("armor.leggings.gold", 16444, ArmorMaterial.GOLD, 2));
     public static Item armorBootsGold = (new ItemArmor("armor.boots.gold", 16445, ArmorMaterial.GOLD, 3));
     public static Item flint = (new Item("flint", 16446));
-    public static Item foodPorkchopRaw = (new ItemFood("food.porkchop.raw", 16447, 3, true));
-    public static Item foodPorkchopCooked = (new ItemFood("food.porkchop.cooked", 16448, 8, true));
+    public static Item foodPorkchopRaw = (new ItemFood("food.porkchop.raw", 16447, 3, 8, true, 16));
+    public static Item foodPorkchopCooked = (new ItemFood("food.porkchop.cooked", 16448, 8, 8, true, 16));
     public static Item painting = (new ItemPainting("painting", 16449));
-    public static Item foodAppleGold = (new ItemFood("food.apple.gold", 16450, 42, false));
+    public static Item foodAppleGold = (new ItemFood("food.apple.gold", 16450, 42, 0, false, 16));
     public static Item sign = (new ItemSign("sign", 16451));
-    public static Item doorOak = (new ItemDoor("door.oak", 16452, Material.wood));
+    public static Item doorOak = (new ItemDoor("door.oak", 16452, Block.doorPlanksOakBottom, Block.doorPlanksOakTop));
     public static Item bucket = (new ItemBucketEmpty("bucket", 16453));
     public static Item bucketWater = (new ItemBucket("bucket.water", 16454, Block.fluidWaterFlowing)).setContainerItem(bucket);
     public static Item bucketLava = (new ItemBucket("bucket.lava", 16455, Block.fluidLavaFlowing)).setContainerItem(bucket);
     public static Item minecart = (new ItemMinecart("minecart", 16456, 0));
     public static Item saddle = (new ItemSaddle("saddle", 16457));
-    public static Item doorIron = (new ItemDoor("door.iron", 16458, Material.metal));
+    public static Item doorIron = (new ItemDoor("door.iron", 16458, Block.doorIronBottom, Block.doorIronTop));
     public static Item dustRedstone = (new ItemPlaceable("dust.redstone", 16459, Block.wireRedstone));
     public static Item ammoSnowball = (new ItemSnowball("ammo.snowball", 16460));
     public static Item boat = (new ItemBoat("boat", 16461));
@@ -360,15 +354,15 @@ public class Item
     public static Item toolFishingrod = (new ItemFishingRod("tool.fishingrod", 16474));
     public static Item toolClock = (new Item("tool.clock", 16475));
     public static Item dustGlowstone = (new Item("dust.glowstone", 16476));
-    public static Item foodFishRaw = (new ItemFoodStackable("food.fish.raw", 16477, 2, false,4));
-    public static Item foodFishCooked = (new ItemFoodStackable("food.fish.cooked", 16478, 5, false, 4));
+    public static Item foodFishRaw = (new ItemFood("food.fish.raw", 16477, 2, 6, false, 16));
+    public static Item foodFishCooked = (new ItemFood("food.fish.cooked", 16478, 5, 6, false, 16));
     public static Item dye = (new ItemDye("dye", 16479));
     public static Item bone = (new Item("bone", 16480));
     public static Item dustSugar = (new Item("dust.sugar", 16481));
     public static Item foodCake = (new ItemPlaceable("food.cake", 16482, Block.cake)).setMaxStackSize(1);
     public static Item bed = (new ItemBed("bed", 16483)).setMaxStackSize(1);
     public static Item repeater = (new ItemPlaceable("repeater", 16484, Block.repeaterIdle));
-    public static Item foodCookie = (new ItemFoodStackable("food.cookie", 16485, 1, false, 8));
+    public static Item foodCookie = (new ItemFood("food.cookie", 16485, 1, 0, false, 16));
     public static ItemMap map = new ItemMap("map", 16486);
     public static ItemToolShears toolShears = new ItemToolShears("tool.shears", 16487, ToolMaterial.iron);
     public static Item record13 = (new ItemRecord("record.13", 18384, "13"));
@@ -388,8 +382,8 @@ public class Item
     public static Item armorChestplateSteel = (new ItemArmor("armor.chestplate.steel", 16490, ArmorMaterial.STEEL, 1));
     public static Item armorLeggingsSteel = (new ItemArmor("armor.leggings.steel", 16491, ArmorMaterial.STEEL, 2));
     public static Item armorBootsSteel = (new ItemArmor("armor.boots.steel", 16492, ArmorMaterial.STEEL, 3));
-    
-    public static Item toolSwordSteel = (new ItemToolSword("tool.sword.steel", 16493, ToolMaterial.steel)).withTags(ItemTags.preventCreativeMining);
+
+    public static Item toolSwordSteel = (new ItemToolSword("tool.sword.steel", 16493, ToolMaterial.steel)).withTags(ItemTags.PREVENT_CREATIVE_MINING);
     public static Item toolShovelSteel = (new ItemToolShovel("tool.shovel.steel", 16494, ToolMaterial.steel));
     public static Item toolPickaxeSteel = (new ItemToolPickaxe("tool.pickaxe.steel", 16495, ToolMaterial.steel));
     public static Item toolAxeSteel = (new ItemToolAxe("tool.axe.steel", 16496, ToolMaterial.steel));
@@ -397,13 +391,13 @@ public class Item
     
     public static Item ingotSteel = (new Item("ingot.steel", 16498));
     public static Item ingotSteelCrude = (new Item("ingot.steel.crude", 16499));
-    public static Item ammoFireball = (new Item("ammo.fireball", 16500)).setNotInCreativeMenu();
+    public static Item ammoFireball = (new Item("ammo.fireball", 16500)).withTags(ItemTags.NOT_IN_CREATIVE_MENU);
     public static Item armorQuiverGold = (new ItemQuiverEndless("armor.quiver.gold", 16501));
     public static Item handcannonUnloaded = (new ItemHandCannonUnloaded("handcannon.unloaded", 16502));
     public static Item chainlink = (new Item("chainlink", 16503));
     public static Item cloth = (new Item("cloth", 16504));
     public static Item ammoChargeExplosive = (new Item("ammo.charge.explosive", 16505)).setMaxStackSize(16);
-    public static Item handcannonLoaded = (new ItemHandCannonLoaded("handcannon.loaded", 16506)).setNotInCreativeMenu();
+    public static Item handcannonLoaded = (new ItemHandCannonLoaded("handcannon.loaded", 16506)).withTags(ItemTags.NOT_IN_CREATIVE_MENU);
     public static Item ammoArrowGold = (new Item("ammo.arrow.gold", 16507));
     public static Item armorQuiver = (new ItemQuiver("armor.quiver", 16508));
     public static Item toolCalendar = (new Item("tool.calendar", 16509));
@@ -412,9 +406,9 @@ public class Item
     public static Item quartz = (new Item("quartz", 16512));
     public static Item olivine = (new Item("olivine", 16513));
     public static Item ammoPebble = (new ItemPebble("ammo.pebble", 16514));
-    public static Item cherry = (new ItemFoodStackable("food.cherry", 16515, 2, false, 2));
-    public static Item bucketIcecream = (new ItemBucketIceCream("bucket.icecream", 16516, 10)).setContainerItem(bucket);
-    public static Item ammoArrowPurple = (new Item("ammo.arrow.purple", 16517)).setNotInCreativeMenu();
+    public static Item cherry = (new ItemFood("food.cherry", 16515, 2, 0, false, 16));
+    public static Item bucketIcecream = (new ItemBucketIceCream("bucket.icecream", 16516, 10, 4)).setContainerItem(bucket);
+    public static Item ammoArrowPurple = (new Item("ammo.arrow.purple", 16517)).withTags(ItemTags.NOT_IN_CREATIVE_MENU);
     public static Item label = (new ItemLabel("label", 16518));
     public static Item jar = (new ItemJar("jar", 16519));
     public static Item lanternFireflyGreen = (new ItemPlaceable("lantern.firefly.green", 16520, Block.lanternFireflyGreen));
@@ -429,6 +423,9 @@ public class Item
     public static Item toolFirestrikerSteel = (new ItemFirestriker("tool.firestriker.steel", 16529)).setMaxDamage(ToolMaterial.steel.getDurability());
     public static Item seedsPumpkin = (new ItemSeeds("seeds.pumpkin", 16530, Block.cropsPumpkin));
     public static Item seat = new ItemPlaceable("seat", 16531, Block.seat).setMaxStackSize(64);
+    public static Item doorOakPainted = (new ItemDoorPainted("door.oak.painted", 16532, Block.doorPlanksOakPaintedBottom, Block.doorPlanksOakPaintedTop));
+    public static Item doorGlass = (new ItemDoor("door.glass", 16533, Block.doorGlassBottom, Block.doorGlassTop));
+    public static Item rope = new ItemPlaceable("rope", 16534, Block.rope);
 
 
     public static int highestItemId = 0;
@@ -438,7 +435,6 @@ public class Item
     protected boolean hasSubtypes;
     private Item containerItem;
     private String key;
-    public boolean notInCreativeMenu;
 
     static 
     {
diff --git a/src/main/java/net/minecraft/core/item/ItemBucketIceCream.java b/src/main/java/net/minecraft/core/item/ItemBucketIceCream.java
index d122ff370..8e2f8d4d2 100644
--- a/src/main/java/net/minecraft/core/item/ItemBucketIceCream.java
+++ b/src/main/java/net/minecraft/core/item/ItemBucketIceCream.java
@@ -3,28 +3,20 @@ package net.minecraft.core.item;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.world.World;
 
-public class ItemBucketIceCream extends Item{
+public class ItemBucketIceCream extends ItemFood {
 
-    public ItemBucketIceCream(String name, int id, int healAmount)
+    public ItemBucketIceCream(String name, int id, int healAmount, int ticksPerHeal)
     {
-        super(name, id);
-        this.healAmount = healAmount;
+        super(name, id, healAmount, ticksPerHeal, false, 1);
         maxStackSize = 1;
     }
     @Override
     public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         if (entityplayer.getHealth() < entityplayer.getMaxHealth()){
-            entityplayer.heal(healAmount);
+            super.onItemRightClick(itemstack, world, entityplayer);
             return new ItemStack(Item.bucket);
         }
         return itemstack;
     }
-
-    public int getHealAmount()
-    {
-        return healAmount;
-    }
-
-    protected int healAmount;
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemDoor.java b/src/main/java/net/minecraft/core/item/ItemDoor.java
index ea1951c4c..ae5af701a 100644
--- a/src/main/java/net/minecraft/core/item/ItemDoor.java
+++ b/src/main/java/net/minecraft/core/item/ItemDoor.java
@@ -14,12 +14,15 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 public class ItemDoor extends Item {
+	protected final Block doorBlockBottom;
+	protected final Block doorBlockTop;
 
-	public ItemDoor(String name, int id, Material material) {
+	public ItemDoor(String name, int id, Block doorBlockBottom, Block doorBlockTop) {
 		super(name, id);
-		doorMaterial = material;
 		maxStackSize = 64;
-	}
+        this.doorBlockBottom = doorBlockBottom;
+        this.doorBlockTop = doorBlockTop;
+    }
 
 	@Override
 	public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
@@ -28,15 +31,6 @@ public class ItemDoor extends Item {
 			blockY += side.getOffsetY();
 			blockZ += side.getOffsetZ();
 		}
-		Block doorBlockBottom;
-		Block doorBlockTop;
-		if(doorMaterial == Material.wood) {
-			doorBlockBottom = Block.doorPlanksOakBottom;
-			doorBlockTop = Block.doorPlanksOakTop;
-		} else {
-			doorBlockBottom = Block.doorIronBottom;
-			doorBlockTop = Block.doorIronTop;
-		}
 		if(!doorBlockBottom.canPlaceBlockAt(world, blockX, blockY, blockZ)) {
 			return false;
 		}
diff --git a/src/main/java/net/minecraft/core/item/ItemDoorPainted.java b/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
new file mode 100644
index 000000000..a03b6fdce
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
@@ -0,0 +1,65 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockWool;
+import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public class ItemDoorPainted extends ItemDoor{
+    public ItemDoorPainted(String name, int id, Block doorBottom, Block doorTopId) {
+        super(name, id, doorBottom, doorTopId);
+    }
+    @Override
+    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+        if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
+            blockX += side.getOffsetX();
+            blockY += side.getOffsetY();
+            blockZ += side.getOffsetZ();
+        }
+        if(!doorBlockBottom.canPlaceBlockAt(world, blockX, blockY, blockZ)) {
+            return false;
+        }
+
+        Direction dir = entityplayer.getHorizontalPlacementDirection(side).rotate(3);
+        int meta = dir.getHorizontalIndex();
+
+        int xOffset = -dir.getOffsetX();
+        int zOffset = -dir.getOffsetZ();
+
+        int isSolidBlockLeft = (world.isBlockNormalCube(blockX - xOffset, blockY, blockZ - zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX - xOffset, blockY + 1, blockZ - zOffset) ? 1 : 0);
+        int isSolidBlockRight = (world.isBlockNormalCube(blockX + xOffset, blockY, blockZ + zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX + xOffset, blockY + 1, blockZ + zOffset) ? 1 : 0);
+        boolean isDoorLeft = world.getBlockId(blockX - xOffset, blockY, blockZ - zOffset) == doorBlockBottom.id || world.getBlockId(blockX - xOffset, blockY + 1, blockZ - zOffset) == doorBlockTop.id;
+        boolean isDoorRight = world.getBlockId(blockX + xOffset, blockY, blockZ + zOffset) == doorBlockBottom.id || world.getBlockId(blockX + xOffset, blockY + 1, blockZ + zOffset) == doorBlockTop.id;
+        boolean isMirrored = false;
+
+        if(isDoorLeft && !isDoorRight) {
+            isMirrored = true;
+        } else if(isSolidBlockRight > isSolidBlockLeft) {
+            isMirrored = true;
+        }
+        if(isMirrored) {
+            meta = meta - 1 & 3;
+            meta += 4;
+            meta |= 0x8;
+        }
+        meta |= (15 - itemstack.getMetadata()) << 4 &0xF0;
+
+        world.editingBlocks = true;
+        world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, doorBlockBottom.id, meta);
+        world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, doorBlockTop.id, meta);
+        world.editingBlocks = false;
+        world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, doorBlockBottom.id);
+        world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, doorBlockTop.id);
+        world.playBlockSoundEffect(entityplayer,blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, doorBlockBottom, EnumBlockSoundEffectType.PLACE);
+        itemstack.consumeItem(entityplayer);
+        return true;
+    }
+    @Override
+    public String getLanguageKey(ItemStack itemstack)
+    {
+        return (new StringBuilder()).append(super.getKey()).append(".").append(ItemDye.dyeColors[itemstack.getMetadata() & 0xF]).toString();
+    }
+}
diff --git a/src/main/java/net/minecraft/core/item/ItemFishingRod.java b/src/main/java/net/minecraft/core/item/ItemFishingRod.java
index 4b9a2dd7e..4429b3073 100644
--- a/src/main/java/net/minecraft/core/item/ItemFishingRod.java
+++ b/src/main/java/net/minecraft/core/item/ItemFishingRod.java
@@ -21,10 +21,10 @@ public class ItemFishingRod extends Item
     @Override
     public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
-        if(entityplayer.fishEntity != null)
+        if(entityplayer.bobberEntity != null)
         {
-            int i = entityplayer.fishEntity.catchFish();
-            itemstack.damageItem(i, entityplayer);
+            int damage = entityplayer.bobberEntity.yoink();
+            itemstack.damageItem(damage, entityplayer);
         } else
         {
             world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
diff --git a/src/main/java/net/minecraft/core/item/ItemFood.java b/src/main/java/net/minecraft/core/item/ItemFood.java
index 92c5c48f1..81b46345a 100644
--- a/src/main/java/net/minecraft/core/item/ItemFood.java
+++ b/src/main/java/net/minecraft/core/item/ItemFood.java
@@ -1,28 +1,29 @@
 package net.minecraft.core.item;
 
-
-// Referenced classes of package net.minecraft.src:
-//            Item, ItemStack, EntityPlayer, World
-
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.world.World;
 
 public class ItemFood extends Item
 {
+    private final int healAmount;
+    private final boolean isWolfsFavoriteMeat;
+    private final int ticksPerHeal;
 
-    public ItemFood(String name, int id, int healAmount, boolean favouriteWolfMeat)
+    public ItemFood(String name, int id, int healAmount, int ticksPerHeal, boolean favouriteWolfMeat, int maxStackSize)
     {
         super(name, id);
         this.healAmount = healAmount;
-        isWolfsFavoriteMeat = favouriteWolfMeat;
-        maxStackSize = 1;
+        this.ticksPerHeal = ticksPerHeal;
+        this.isWolfsFavoriteMeat = favouriteWolfMeat;
+
+        this.maxStackSize = maxStackSize;
     }
 
     @Override
     public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         if(entityplayer.getHealth() < entityplayer.getMaxHealth() && itemstack.consumeItem(entityplayer)) {
-            entityplayer.heal(healAmount);
+            entityplayer.eatFood(this);
         }
         return itemstack;
     }
@@ -32,11 +33,12 @@ public class ItemFood extends Item
         return healAmount;
     }
 
+    public int getTicksPerHeal() {
+        return ticksPerHeal;
+    }
+
     public boolean getIsWolfsFavoriteMeat()
     {
         return isWolfsFavoriteMeat;
     }
-
-    protected int healAmount;
-    protected boolean isWolfsFavoriteMeat;
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemSoup.java b/src/main/java/net/minecraft/core/item/ItemSoup.java
index 49cc14755..dfc8d27bb 100644
--- a/src/main/java/net/minecraft/core/item/ItemSoup.java
+++ b/src/main/java/net/minecraft/core/item/ItemSoup.java
@@ -1,19 +1,14 @@
 package net.minecraft.core.item;
 
-
-// Referenced classes of package net.minecraft.src:
-//            ItemFood, ItemStack, Item, World, 
-//            EntityPlayer
-
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.world.World;
 
 public class ItemSoup extends ItemFood
 {
 
-    public ItemSoup(String name, int id, int j)
+    public ItemSoup(String name, int id, int healAmount, int ticksPerHeal)
     {
-        super(name, id, j, false);
+        super(name, id, healAmount, ticksPerHeal, false, 1);
     }
 
     @Override
